const templateCache = require('gulp-angular-templatecache');
const concat        = require('gulp-concat');
const clean         = require('gulp-clean');
const htmlmin       = require('gulp-htmlmin');
const rename        = require('gulp-rename');
const uglify        = require('gulp-uglify');
const gulp          = require('gulp');
const pump          = require('pump');
const jshint        = require('gulp-jshint');
const replace       = require('gulp-replace');

var paths = {
    srcJS: 'src/js/*.js',
    tmp:   'tmp',
    dist:  'dist/'
};

gulp.task('uglify', ['clean'], function() {
    return pump(
        [
            gulp.src(paths.srcJS),
            concat('foca-filtros.js'),
            gulp.dest(paths.tmp),
            rename('foca-filtros.min.js'),
            uglify(),
            gulp.dest(paths.dist)
        ]
    );
});

gulp.task('clean', function() {
    return gulp.src(['tmp', 'dist'], {read: false})
    .pipe(clean());
});

gulp.task('pre-commit', function() {
    pump(
        [
            gulp.src(paths.srcJS),
            jshint('.jshintrc'),
            jshint.reporter('default'),
            jshint.reporter('fail')
        ]
    );
});

gulp.task('clean-post-install', function() {
    return gulp.src(['src', 'tmp', '.jshintrc','readme.md', '.gitignore', 'gulpfile.js',
                     'index.html'], {read: false})
    .pipe(clean());
});

gulp.task('webserver', function() {
    pump [
        connect.server({port: 3000})
    ]
});

gulp.task('default', ['webserver']);

gulp.task('watch', function() {
    return gulp.watch([paths.srcJS], ['uglify']);
});

gulp.task('copy', ['uglify'], function() {
    return gulp.src('dist/*.js')
        .pipe(gulp.dest('../../wrapper-demo/node_modules/foca-filtros/dist'));
});

gulp.task('watchAndCopy', function() {
    return gulp.watch([paths.srcJS], ['copy']);
});
